using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Commands.Register;

public class RegisterCommandHandler : IRequestHandler<RegisterCommand>
{
    private readonly AuthenticationService _authenticationService;

    public RegisterCommandHandler(AuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task Handle(
        RegisterCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RegisterAsync(
            request.Email, request.Password, cancellationToken);
    }
}
