using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Commands.RenewAccessToken;

public class RenewAccessTokenCommandHandler :
    IRequestHandler<RenewAccessTokenCommand, TokensModel>
{
    private readonly AuthenticationService _authenticationService;

    public RenewAccessTokenCommandHandler(AuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task<TokensModel> Handle(
        RenewAccessTokenCommand request, CancellationToken cancellationToken)
    {
        return await _authenticationService.RenewAccessTokenAsync(
            request.RefreshToken, cancellationToken);
    }
}
