using cuqmbr.TravelGuide.Application.Common.Authorization;
using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR.Behaviors.Authorization;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Commands.RevokeRefreshToken;

public class RevokeRefreshTokenCommandAuthorizer :
    AbstractRequestAuthorizer<RevokeRefreshTokenCommand>
{
    private readonly SessionUserService _sessionUserService;

    public RevokeRefreshTokenCommandAuthorizer(SessionUserService currentUserService)
    {
        _sessionUserService = currentUserService;
    }

    public override void BuildPolicy(RevokeRefreshTokenCommand request)
    {
        UseRequirement(new MustBeAuthenticatedRequirement
        {
            IsAuthenticated = _sessionUserService.IsAuthenticated
        });
    }
}
