using cuqmbr.TravelGuide.Application.Common.Interfaces.Persistence.Repositories;

namespace cuqmbr.TravelGuide.Application.Common.Interfaces.Persistence;

public interface UnitOfWork : IDisposable
{
    CountryRepository CountryRepository { get; }

    RegionRepository RegionRepository { get; }

    CityRepository CityRepository { get; }

    AddressRepository AddressRepository { get; }

    RouteRepository RouteRepository { get; }

    VehicleRepository VehicleRepository { get; }

    BusRepository BusRepository { get; }

    AircraftRepository AircraftRepository { get; }

    TrainRepository TrainRepository { get; }

    VehicleEnrollmentRepository VehicleEnrollmentRepository { get; }

    RouteAddressRepository RouteAddressRepository { get; }

    CompanyRepository CompanyRepository { get; }

    EmployeeRepository EmployeeRepository { get; }

    TicketGroupRepository TicketGroupRepository { get; }

    TicketRepository TicketRepository { get; }

    RouteAddressDetailRepository RouteAddressDetailRepository { get; }

    int Save();

    Task<int> SaveAsync(CancellationToken cancellationToken);
}
