using cuqmbr.TravelGuide.Domain.Enums;

namespace cuqmbr.TravelGuide.Application.Common.Models;

public abstract class IdentityRole : Enumeration<IdentityRole>
{
    public static readonly IdentityRole Administrator = new AdministratorRole();
    public static readonly IdentityRole User = new UserRole();

    protected IdentityRole(int value, string name) : base(value, name) { }

    private sealed class AdministratorRole : IdentityRole
    {
        public AdministratorRole() : base(0, "administrator") { }
    }

    private sealed class UserRole : IdentityRole
    {
        public UserRole() : base(1, "user") { }
    }
}
