using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.Employees;

public sealed class EmployeeDocumentDto : IMapFrom<EmployeeDocument>
{
    public string DocumentType { get; set; }

    public string Information { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<EmployeeDocument, EmployeeDocumentDto>()
            .ForMember(
                d => d.DocumentType,
                opt => opt.MapFrom(s => s.DocumentType.Name));
    }
}
