using cuqmbr.TravelGuide.Application.Common.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Employees.Queries.GetEmployeesPage;

public record GetEmployeesPageQuery : IRequest<PaginatedList<EmployeeDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public Sex? Sex { get; set; }

    public DateOnly? BirthDateGreaterThanOrEqualTo { get; set; }

    public DateOnly? BirthDateLessThanOrEqualTo { get; set; }

    public Guid? CompanyGuid { get; set; }
}
