using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;
using cuqmbr.TravelGuide.Application.TicketGroups.Models;

namespace cuqmbr.TravelGuide.Application.TicketGroups.Commands.AddTicketGroup;

public record AddTicketGroupCommand : IRequest<TicketGroupDto>
{
    public string PassangerFirstName { get; set; }

    public string PassangerLastName { get; set; }

    public string PassangerPatronymic { get; set; }

    public Sex PassangerSex { get; set; }

    public DateOnly PassangerBirthDate { get; set; }

    public DateTimeOffset PurchaseTime { get; set; }

    public bool Returned { get; set; }


    public ICollection<TicketModel> Tickets { get; set; }
}
