using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application
    .VehicleEnrollmentSearch.Queries.SearchShortest;

public record SearchShortestQuery :
    IRequest<VehicleEnrollmentSearchDto>
{
    public Guid DepartureAddressGuid { get; set; }

    public Guid ArrivalAddressGuid { get; set; }

    public DateOnly DepartureDate { get; set; }

    public HashSet<VehicleType> VehicleTypes { get; set; }

    public bool ShortestByCost { get; set; }

    public bool ShortestByTime { get; set; }
}
