using cuqmbr.TravelGuide.Application.VehicleEnrollments.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.VehicleEnrollments
    .Commands.AddVehicleEnrollment;

public record AddVehicleEnrollmentCommand : IRequest<VehicleEnrollmentDto>
{
    public DateTimeOffset DepartureTime { get; set; }

    public Currency Currency { get; set; }


    public Guid VehicleGuid { get; set; }

    public Guid RouteGuid { get; set; }

    public ICollection<RouteAddressDetailModel> RouteAddressDetails { get; set; }
}
