namespace cuqmbr.TravelGuide.Domain.Enums;

// Do not forget to update the schema of your database when changing
// this class (if you use it with a database)

public abstract class Sex : Enumeration<Sex>
{
    public static readonly Sex Male = new MaleSex();
    public static readonly Sex Female = new FemaleSex();

    protected Sex(int value, string name) : base(value, name) { }

    private sealed class MaleSex : Sex
    {
        public MaleSex() : base(Int32.MaxValue, "male") { }
    }

    private sealed class FemaleSex : Sex
    {
        public FemaleSex() : base(Int32.MinValue, "female") { }
    }
}
