namespace cuqmbr.TravelGuide.Domain.Enums;

// Do not forget to update the schema of your database when changing
// this class (if you use it with a database)

public abstract class VehicleType : Enumeration<VehicleType>
{
    public static readonly VehicleType Bus = new BusVehicleType();
    public static readonly VehicleType Train = new TrainVehicleType();
    public static readonly VehicleType Aircraft = new AircraftVehicleType();

    protected VehicleType(int value, string name) : base(value, name) { }

    private sealed class BusVehicleType : VehicleType
    {
        public BusVehicleType() : base(0, "bus") { }
    }

    private sealed class TrainVehicleType : VehicleType
    {
        public TrainVehicleType() : base(1, "train") { }
    }

    private sealed class AircraftVehicleType : VehicleType
    {
        public AircraftVehicleType() : base(2, "aircraft") { }
    }
}
