using Microsoft.AspNetCore.Mvc;
using cuqmbr.TravelGuide.Application.Authenticaion;
using cuqmbr.TravelGuide.Application.Authenticaion.Queries.Login;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.Register;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.RenewAccessToken;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.RevokeRefreshToken;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands
    .RenewAccessTokenWithCookie;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands
    .RevokeRefreshTokenWithCookie;

namespace cuqmbr.TravelGuide.HttpApi.Controllers;

[Route("authentication")]
public class AuthenticationController : ControllerBase
{
    [HttpPost("register")]
    public async Task Register(
        [FromBody] RegisterCommand command,
        CancellationToken cancellationToken)
    {
        await Mediator.Send(command, cancellationToken);
    }

    [HttpPost("login")]
    public async Task<TokensModel> Login(
        [FromBody] LoginQuery query,
        CancellationToken cancellationToken)
    {
        return await Mediator.Send(query, cancellationToken);
    }

    // [HttpPost("loginWithCookie")]
    // public async Task<TokensModel> LoginWithCookie(
    //     [FromBody] LoginQuery query,
    //     CancellationToken cancellationToken)
    // {
    //     var tokens = await Mediator.Send(query, cancellationToken);
    //
    //     HttpContext.Response.Cookies.Delete("refreshToken");
    //
    //     var cookieOptions = new CookieOptions()
    //     {
    //         Path = "/",
    //         Expires = DateTimeOffset.MaxValue,
    //         HttpOnly = true
    //     };
    //
    //     HttpContext.Response.Cookies.Append(
    //         "refreshToken", tokens.RefreshToken, cookieOptions);
    //
    //     return tokens;
    // }

    [HttpPost("renewAccessToken")]
    public async Task<TokensModel> RenewAccessToken(
        [FromBody] RenewAccessTokenCommand command,
        CancellationToken cancellationToken)
    {
        return await Mediator.Send(command, cancellationToken);
    }

    // [HttpPost("renewAccessTokenWithCookie")]
    // public async Task<TokensModel> RenewAccessTokenWithCookie(
    //     [FromBody] RenewAccessTokenWithCookieCommand command,
    //     CancellationToken cancellationToken)
    // {
    //     return await Mediator.Send(command, cancellationToken);
    // }

    [HttpPost("revokeRefreshToken")]
    public async Task RevokeRefreshToken(
        [FromBody] RevokeRefreshTokenCommand command,
        CancellationToken cancellationToken)
    {
        await Mediator.Send(command, cancellationToken);
    }

    // [HttpPost("revokeRefreshTokenWithCookie")]
    // public async Task RevokeRefreshTokenWithCookie(
    //     [FromBody] RevokeRefreshTokenWithCookieCommand command,
    //     CancellationToken cancellationToken)
    // {
    //     await Mediator.Send(command, cancellationToken);
    //     HttpContext.Response.Cookies.Delete("refreshToken");
    // }
}
