using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Localization;
using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using cuqmbr.TravelGuide.Application.Common.Interfaces.Persistence;

namespace cuqmbr.TravelGuide.HttpApi.Controllers;

[Route("tests")]
public class TestsController : ControllerBase
{
    private readonly IStringLocalizer _localizer;
    private readonly UnitOfWork _unitOfWork;

    public TestsController(
        SessionCultureService cultureService,
        IStringLocalizer localizer,
        UnitOfWork unitOfWork)
    {
        _localizer = localizer;
        _unitOfWork = unitOfWork;
    }

    [HttpGet("getLocalizedString/{inputString}")]
    public Task<string> GetLocalizedString(
        [FromRoute] string inputString,
        CancellationToken cancellationToken)
    {
        return Task.FromResult<string>(_localizer[inputString]);
    }

    [HttpGet("trigger")]
    public async Task Trigger(CancellationToken cancellationToken)
    {
        // await _unitOfWork.BusRepository.AddOneAsync(
        //     new Domain.Entities.Bus()
        //     {
        //         Number = "AB1234MK",
        //         Model = "This is a fancy bus model",
        //         Capacity = 40
        //     },
        //     cancellationToken);
        //
        // await _unitOfWork.SaveAsync(cancellationToken);
        // _unitOfWork.Dispose();

        var vehicles = await _unitOfWork.VehicleRepository
            .GetPageAsync(1, 10, cancellationToken);
    }
}
