using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using cuqmbr.TravelGuide.Domain.Enums;

namespace cuqmbr.TravelGuide.HttpApi.Services;

public sealed class AspNetSessionCurrencyService : SessionCurrencyService
{
    private readonly HttpContext _httpContext;

    public AspNetSessionCurrencyService(IHttpContextAccessor httpContextAccessor)
    {
        _httpContext = httpContextAccessor.HttpContext;
    }

    public Currency Currency
    {
        get
        {
            string? headerCurrencyCode =
                _httpContext.Request.Headers["Accept-Currency"];

            string currencyCode =  
                headerCurrencyCode?.ToUpper() ??
                cuqmbr.TravelGuide.Domain.Enums.Currency.Default.Name;

            var resultCurrency = 
                cuqmbr.TravelGuide.Domain.Enums.Currency.FromName(currencyCode);

            if (resultCurrency == null)
            {
                resultCurrency = 
                    cuqmbr.TravelGuide.Domain.Enums.Currency.Default;
            }

            return resultCurrency;
        }
    }
}
