using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;

namespace cuqmbr.TravelGuide.HttpApi.Services;

public sealed class AspNetSessionTimeZoneService : SessionTimeZoneService
{
    private readonly HttpContext _httpContext;

    public AspNetSessionTimeZoneService(IHttpContextAccessor httpContextAccessor)
    {
        _httpContext = httpContextAccessor.HttpContext!;
    }

    public TimeZoneInfo TimeZone
    {
        get
        {
            string? tzId = _httpContext.Request.Headers["Accept-TimeZone"];

            if (tzId == null)
            {
                tzId = "UTC";
            }

            var tzFound = TimeZoneInfo.TryFindSystemTimeZoneById(tzId, out var tz);

            return tzFound ? tz! : TimeZoneInfo.Utc;
        }
    }
}
