using cuqmbr.TravelGuide.Domain.Entities;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace cuqmbr.TravelGuide.Persistence.PostgreSql.Configurations;

public class BusConfiguration : IEntityTypeConfiguration<Bus>
{
    public void Configure(EntityTypeBuilder<Bus> builder)
    {
        builder
            .HasBaseType<Vehicle>();


        builder
            .Property(b => b.Number)
            .HasColumnName("number")
            .HasColumnType("varchar(32)")
            .IsRequired(true);

        builder
            .Property(b => b.Model)
            .HasColumnName("model")
            .HasColumnType("varchar(64)")
            .IsRequired(true);

        builder
            .Property(b => b.Capacity)
            .HasColumnName("capacity")
            .HasColumnType("smallint")
            .IsRequired(true);
    }
}
